Index: trunk/src/VBox/Main/glue/glue-java.xsl
===================================================================
--- trunk/src/VBox/Main/glue/glue-java.xsl	(revision 53354)
+++ trunk/src/VBox/Main/glue/glue-java.xsl	(revision 53385)
@@ -219,11 +219,34 @@
   </xsl:variable>
 
+  <!-- &amp;, &lt; and &gt; must remain as they are or javadoc 8 throws a fit. -->
   <xsl:variable name="rep4">
-    <xsl:call-template name="string-trim">
-      <xsl:with-param name="text" select="$rep3"/>
+    <xsl:call-template name="string-replace">
+      <xsl:with-param name="haystack" select="$rep3"/>
+      <xsl:with-param name="needle" select="'&amp;'"/>
+      <xsl:with-param name="replacement" select="'&amp;amp;'"/>
     </xsl:call-template>
   </xsl:variable>
-
-  <xsl:value-of select="$rep4"/>
+  <xsl:variable name="rep5">
+    <xsl:call-template name="string-replace">
+      <xsl:with-param name="haystack" select="$rep4"/>
+      <xsl:with-param name="needle" select="'&lt;'"/>
+      <xsl:with-param name="replacement" select="'&amp;lt;'"/>
+    </xsl:call-template>
+  </xsl:variable>
+  <xsl:variable name="rep6">
+    <xsl:call-template name="string-replace">
+      <xsl:with-param name="haystack" select="$rep5"/>
+      <xsl:with-param name="needle" select="'&gt;'"/>
+      <xsl:with-param name="replacement" select="'&amp;gt;'"/>
+    </xsl:call-template>
+  </xsl:variable>
+
+  <xsl:variable name="rep7">
+    <xsl:call-template name="string-trim">
+      <xsl:with-param name="text" select="$rep6"/>
+    </xsl:call-template>
+  </xsl:variable>
+
+  <xsl:value-of select="$rep7"/>
 </xsl:template>
 
@@ -234,5 +257,9 @@
 <xsl:template match="desc//*">
   <xsl:variable name="tagname" select="local-name()"/>
-  <xsl:value-of select="concat('&lt;', $tagname, '&gt;')"/>
+  <xsl:value-of select="concat('&lt;', $tagname)"/>
+  <xsl:if test="$tagname = 'table'"> <!-- javadoc 8 fudge -->
+    <xsl:text> summary=""</xsl:text>
+  </xsl:if>
+  <xsl:text>&gt;</xsl:text>
   <xsl:apply-templates/>
   <xsl:value-of select="concat('&lt;/', $tagname, '&gt;')"/>
@@ -412,5 +439,5 @@
   <xsl:if test="result">
     <xsl:text>&#10;Expected result codes:&#10;</xsl:text>
-    <xsl:text>&lt;table&gt;&#10;</xsl:text>
+    <xsl:text>&lt;table summary=""&gt;&#10;</xsl:text>
     <xsl:for-each select="result">
       <xsl:text>&lt;tr&gt;</xsl:text>
@@ -426,5 +453,5 @@
       <xsl:apply-templates select="text() | *[not(self::note or self::see or
                                                   self::result)]"/>
-      <xsl:text>&lt;/td&gt;&lt;tr&gt;&#10;</xsl:text>
+      <xsl:text>&lt;/td&gt;&lt;/tr&gt;&#10;</xsl:text>
     </xsl:for-each>
     <xsl:text>&lt;/table&gt;&#10;</xsl:text>
@@ -446,5 +473,5 @@
   <xsl:apply-templates select="." mode="begin"/>
   <xsl:apply-templates select="." mode="middle"/>
-  <xsl:text>&#10;Interface ID: &lt;tt&gt;{</xsl:text>
+  <xsl:text>&#10;&#10;Interface ID: &lt;tt&gt;{</xsl:text>
   <xsl:call-template name="uppercase">
     <xsl:with-param name="str" select="../@uuid"/>
@@ -465,4 +492,5 @@
     <xsl:with-param name="type" select="../@type"/>
     <xsl:with-param name="safearray" select="../@safearray"/>
+    <xsl:with-param name="doubleescape">yes</xsl:with-param>
   </xsl:call-template>
   <xsl:text>&#10;</xsl:text>
@@ -483,4 +511,5 @@
     <xsl:with-param name="type" select="../@type"/>
     <xsl:with-param name="safearray" select="../@safearray"/>
+    <xsl:with-param name="doubleescape">yes</xsl:with-param>
   </xsl:call-template>
   <xsl:text>&#10;</xsl:text>
@@ -715,4 +744,5 @@
   <xsl:param name="forceelem" />
   <xsl:param name="skiplisttype" />
+  <xsl:param name="doubleescape" />
 
   <xsl:variable name="needarray" select="($safearray='yes') and not($forceelem='yes')" />
@@ -722,5 +752,12 @@
     <xsl:text>List</xsl:text>
     <xsl:if test="not($skiplisttype='yes')">
-      <xsl:text>&lt;</xsl:text>
+      <xsl:choose>
+        <xsl:when test="$doubleescape='yes'">
+          <xsl:text>&amp;lt;</xsl:text>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:text>&lt;</xsl:text>
+        </xsl:otherwise>
+      </xsl:choose>
     </xsl:if>
   </xsl:if>
@@ -748,5 +785,12 @@
     <xsl:when test="($needlist)">
       <xsl:if test="not($skiplisttype='yes')">
-        <xsl:text>&gt;</xsl:text>
+        <xsl:choose>
+          <xsl:when test="$doubleescape='yes'">
+            <xsl:text>&amp;gt;</xsl:text>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:text>&gt;</xsl:text>
+          </xsl:otherwise>
+        </xsl:choose>
       </xsl:if>
     </xsl:when>
Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 53354)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 53385)
@@ -11485,10 +11485,11 @@
       <param name="environment" type="wstring" dir="in" safearray="yes">
         <desc>
-          <para>Environment variables that can be set while the command is being
+          Environment variables that can be set while the command is being
           executed, in form of "NAME=VALUE"; one pair per entry. To unset a
-          variable just set its name ("NAME") without a value.</para>
-          <para>This parameter can be used to override environment variables set by
+          variable just set its name ("NAME") without a value.
+
+          This parameter can be used to override environment variables set by
           the guest session, which will be applied to the newly started process
-          in any case.</para>
+          in any case.
         </desc>
       </param>
@@ -11514,9 +11515,8 @@
     <method name="processCreateEx">
       <desc>
-        <para>Creates a new process running on the guest. Extended version for
-          also setting the process priority and affinity.</para>
-
-        <para>See <link to="IGuestSession::processCreate"/> for more
-          information.</para>
+        Creates a new process running on the guest. Extended version for
+        also setting the process priority and affinity.
+
+        See <link to="IGuestSession::processCreate"/> for more information.
       </desc>
       <param name="command" type="wstring" dir="in">
@@ -11531,10 +11531,11 @@
       <param name="environment" type="wstring" dir="in" safearray="yes">
         <desc>
-          <para>Environment variables that can be set while the command is being
+          Environment variables that can be set while the command is being
           executed, in form of "NAME=VALUE"; one pair per entry. To unset a
-          variable just set its name ("NAME") without a value.</para>
-          <para>This parameter can be used to override environment variables set by
+          variable just set its name ("NAME") without a value.
+
+          This parameter can be used to override environment variables set by
           the guest session, which will be applied to the newly started process
-          in any case.</para>
+          in any case.
         </desc>
       </param>